# -*- coding: ISO-8859-1 -*-
# generated by wxGlade 0.3.5.1 on Tue Mar 22 11:28:12 2005

import os
import wx, wx.lib.editor
from solipsis.util.wxutils import _
from solipsis.services.profile.facade import get_facade
from solipsis.services.profile import QUESTION_MARK

# begin wxGlade: dependencies
# end wxGlade

class PersonalPanel(wx.Panel):
    def __init__(self, *args, **kwds):
        # begin wxGlade: PersonalPanel.__init__
        kwds["style"] = wx.TAB_TRAVERSAL
        wx.Panel.__init__(self, *args, **kwds)
        self.address_sizer_staticbox = wx.StaticBox(self, -1, _("Address"))
        self.description_sizer_staticbox = wx.StaticBox(self, -1, _("Description"))
        self.identity_sizer_staticbox = wx.StaticBox(self, -1, _("Identity"))
        self.title_value = wx.ComboBox(self, -1, choices=["", _("Mr"), _("Mrs"), _("Ms")], style=wx.CB_DROPDOWN|wx.CB_SIMPLE|wx.CB_READONLY)
        self.firstname_value = wx.TextCtrl(self, -1, _("First name"))
        self.lastname_value = wx.TextCtrl(self, -1, _("Last Name"))
        self.nickname_lbl = wx.StaticText(self, -1, _("Pseudo: "))
        self.nickname_value = wx.TextCtrl(self, -1, "")
        self.email_lbl = wx.StaticText(self, -1, _("E-mail: "))
        self.email_value = wx.TextCtrl(self, -1, "")
        self.birthday_lbl = wx.StaticText(self, -1, _("Birthday: "))
        self.birthday_value = wx.TextCtrl(self, -1, _("dd/mm/yyyy"))
        self.language_lbl = wx.StaticText(self, -1, _("Language: "))
        self.language_value = wx.ComboBox(self, -1, choices=["", _("French"), _("English")], style=wx.CB_DROPDOWN|wx.CB_SIMPLE|wx.CB_READONLY)
        self.photo_button = wx.BitmapButton(self, -1, wx.Bitmap(QUESTION_MARK(),wx.BITMAP_TYPE_ANY))
        self.road_value = wx.TextCtrl(self, -1, _("Road"))
        self.postcode_value = wx.TextCtrl(self, -1, _("Postcode"))
        self.city_value = wx.TextCtrl(self, -1, _("City"))
        self.country_value = wx.TextCtrl(self, -1, _("Country"))
        self.description_value = wx.TextCtrl(self, -1, "", style=wx.TE_MULTILINE|wx.HSCROLL|wx.TE_RICH2|wx.TE_LINEWRAP)

        self.__set_properties()
        self.__do_layout()
        # end wxGlade
        
        self.facade = get_facade()
        self.bind_controls()

    # EVENTS
    
    def bind_controls(self):
        """bind all controls with facade"""
        self.title_value.Bind(wx.EVT_COMBOBOX, self.on_title)
        self.firstname_value.Bind(wx.EVT_KILL_FOCUS, self.on_firstname)
        self.lastname_value.Bind(wx.EVT_KILL_FOCUS, self.on_lastname)
        self.nickname_value.Bind(wx.EVT_KILL_FOCUS, self.on_pseudo)
        self.email_value.Bind(wx.EVT_KILL_FOCUS, self.on_email)
        self.birthday_value.Bind(wx.EVT_KILL_FOCUS, self.on_birthday)
        self.language_value.Bind(wx.EVT_COMBOBOX, self.on_language)
        self.photo_button.Bind(wx.EVT_BUTTON, self.on_photo)
        self.road_value.Bind(wx.EVT_KILL_FOCUS, self.on_address)
        self.postcode_value.Bind(wx.EVT_KILL_FOCUS, self.on_postcode)
        self.city_value.Bind(wx.EVT_KILL_FOCUS, self.on_city)
        self.country_value.Bind(wx.EVT_KILL_FOCUS, self.on_country)
        self.description_value.Bind(wx.EVT_KILL_FOCUS, self.on_description)
        
    def on_title(self, evt):
        """language loses focus"""
        self.facade.change_title(evt.GetString())
        evt.Skip()
        
    def on_firstname(self, evt):
        """firstname loses focus"""
        self.facade.change_firstname(evt.GetEventObject().GetValue())
        evt.Skip()
        
    def on_lastname(self, evt):
        """lastname loses focus"""
        self.facade.change_lastname(evt.GetEventObject().GetValue())
        evt.Skip()
    
    def on_pseudo(self, evt):
        """pseudo loses focus"""
        self.facade.change_pseudo(evt.GetEventObject().GetValue())
        evt.Skip()
        
    def on_email(self, evt):
        """email loses focus"""
        self.facade.change_email(evt.GetEventObject().GetValue())
        evt.Skip()
        
    def on_birthday(self, evt):
        """birthday loses focus"""
        self.facade.change_birthday(evt.GetEventObject().GetValue())
        evt.Skip()
        
    def on_language(self, evt):
        """language loses focus"""
        self.facade.change_language(evt.GetString())
        evt.Skip()
        
    def on_address(self, evt):
        """address loses focus"""
        self.facade.change_address(evt.GetEventObject().GetValue())
        evt.Skip()
        
    def on_photo(self, evt):
        """photo clicked"""
        dlg = wx.FileDialog(
            self, message=_("Choose your picture"),
            defaultDir=os.getcwd(), 
            defaultFile="",
            wildcard= "Image GIF (*.gif)|*.gif|" \
            "Image JPEG (*.jpg)|*.jpg|" \
            "Image PNG (*.png)|*.png|" \
            "All files (*.*)|*.*",
            style=wx.OPEN | wx.CHANGE_DIR )
        
        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            self.facade.change_photo(path)
        dlg.Destroy()
        
    def on_postcode(self, evt):
        """postcode loses focus"""
        self.facade.change_postcode(evt.GetEventObject().GetValue())
        evt.Skip()
        
    def on_city(self, evt):
        """city loses focus"""
        self.facade.change_city(evt.GetEventObject().GetValue())
        evt.Skip()
        
    def on_country(self, evt):
        """country loses focus"""
        self.facade.change_country(evt.GetEventObject().GetValue())
        evt.Skip()
        
    def on_description(self, evt):
        """description loses focus"""
        self.facade.change_description(evt.GetEventObject().GetValue())
        evt.Skip()
        
    def __set_properties(self):
        # begin wxGlade: PersonalPanel.__set_properties
        self.title_value.SetSelection(0)
        self.nickname_value.SetToolTipString(_("How you appear to other peers"))
        self.language_value.SetSelection(0)
        self.photo_button.SetSize(self.photo_button.GetBestSize())
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: PersonalPanel.__do_layout
        personal_sizer = wx.FlexGridSizer(2, 1, 0, 0)
        description_sizer = wx.StaticBoxSizer(self.description_sizer_staticbox, wx.HORIZONTAL)
        info_sizer = wx.FlexGridSizer(2, 2, 0, 0)
        address_sizer = wx.StaticBoxSizer(self.address_sizer_staticbox, wx.VERTICAL)
        city_sizer = wx.FlexGridSizer(1, 2, 3, 3)
        identity_sizer = wx.StaticBoxSizer(self.identity_sizer_staticbox, wx.VERTICAL)
        detail_sizer = wx.FlexGridSizer(1, 4, 0, 3)
        contact_sizer = wx.FlexGridSizer(3, 2, 3, 0)
        name_sizer = wx.FlexGridSizer(1, 3, 3, 3)
        name_sizer.Add(self.title_value, 0, wx.FIXED_MINSIZE, 0)
        name_sizer.Add(self.firstname_value, 0, wx.EXPAND|wx.FIXED_MINSIZE, 0)
        name_sizer.Add(self.lastname_value, 0, wx.EXPAND|wx.FIXED_MINSIZE, 0)
        name_sizer.AddGrowableCol(1)
        name_sizer.AddGrowableCol(2)
        identity_sizer.Add(name_sizer, 0, wx.EXPAND, 0)
        contact_sizer.Add(self.nickname_lbl, 0, wx.FIXED_MINSIZE, 0)
        contact_sizer.Add(self.nickname_value, 0, wx.EXPAND|wx.FIXED_MINSIZE, 0)
        contact_sizer.Add(self.email_lbl, 0, wx.FIXED_MINSIZE, 0)
        contact_sizer.Add(self.email_value, 0, wx.EXPAND|wx.FIXED_MINSIZE, 0)
        contact_sizer.AddGrowableCol(1)
        identity_sizer.Add(contact_sizer, 0, wx.TOP|wx.EXPAND, 3)
        detail_sizer.Add(self.birthday_lbl, 0, wx.FIXED_MINSIZE, 0)
        detail_sizer.Add(self.birthday_value, 0, wx.EXPAND|wx.FIXED_MINSIZE, 0)
        detail_sizer.Add(self.language_lbl, 0, wx.FIXED_MINSIZE, 0)
        detail_sizer.Add(self.language_value, 0, wx.EXPAND, 0)
        detail_sizer.AddGrowableCol(1)
        detail_sizer.AddGrowableCol(3)
        identity_sizer.Add(detail_sizer, 1, wx.TOP|wx.EXPAND, 3)
        info_sizer.Add(identity_sizer, 1, wx.EXPAND, 0)
        info_sizer.Add(self.photo_button, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.FIXED_MINSIZE, 3)
        address_sizer.Add(self.road_value, 0, wx.EXPAND|wx.FIXED_MINSIZE, 0)
        city_sizer.Add(self.postcode_value, 0, wx.FIXED_MINSIZE, 0)
        city_sizer.Add(self.city_value, 0, wx.EXPAND|wx.FIXED_MINSIZE, 0)
        city_sizer.AddGrowableCol(1)
        address_sizer.Add(city_sizer, 1, wx.TOP|wx.EXPAND, 3)
        address_sizer.Add(self.country_value, 0, wx.TOP|wx.ALIGN_RIGHT|wx.FIXED_MINSIZE, 3)
        info_sizer.Add(address_sizer, 1, wx.EXPAND, 0)
        info_sizer.Add((20, 20), 0, wx.FIXED_MINSIZE, 0)
        info_sizer.AddGrowableCol(0)
        personal_sizer.Add(info_sizer, 0, wx.ALL|wx.EXPAND, 3)
        description_sizer.Add(self.description_value, 1, wx.EXPAND|wx.FIXED_MINSIZE, 0)
        personal_sizer.Add(description_sizer, 1, wx.EXPAND, 0)
        self.SetAutoLayout(True)
        self.SetSizer(personal_sizer)
        personal_sizer.Fit(self)
        personal_sizer.SetSizeHints(self)
        personal_sizer.AddGrowableRow(1)
        personal_sizer.AddGrowableCol(0)
        # end wxGlade

# end of class PersonalPanel


